
h = require 'maquette' .h
Modal = require './modal.ls'

TaskRemovalModal = (project-id, todod-ws, task) ->
	task ||= {}

	self = {
		title: task.title || ""
		description: task.description || ""
	}

	modal = Modal {
		+visible
		content: h \div.is-danger [ "Do you want to remove the task ?" ]

		validation-label: "Delete"
		validation-classes: {+"is-danger", +"is-outlined"}
		on-validation: ->
			if task.id
				todod-ws.remove-task task.id
	}

	self.render = ->
		modal.render!

	self


module.exports = TaskRemovalModal
